/**
 * @module    mod_treasurehunt/play
 * @package   mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>, Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(["jquery","core/url","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/viewgpx","core/str","mod_treasurehunt/webqr","mod_treasurehunt/jquery.truncate","mod_treasurehunt/dropdown"],(function(e,t,a,o,s,l,n,i){return{playtreasurehunt:function(e,t,a,o,s,l,i,c,d,u){let m=["stageovercome","failedlocation","stage","stagename","stageclue","question","noanswerselected","timeexceeded","searching","continue","noattempts","aerialview","roadview","noresults","startfromhere","nomarks","updates","activitytoendwarning","huntcompleted","discoveredlocation","answerwarning","error","pegmanlabel"],g=m.map((e=>({key:e,component:"treasurehunt"})));n.get_strings(g).done((n=>{let g=[];for(let e=0;e<m.length;e++)g[m[e]]=n[e];if(void 0!==u&&u&&u.custombackgroundurl){let n=new Image;n.addEventListener("load",(function(){u.imgwidth=this.naturalWidth,u.imgheight=this.naturalHeight,r(g,e,t,a,o,s,l,i,c,d,u)})),n.src=u.custombackgroundurl}else r(g,e,t,a,o,s,l,i,c,d,u)}))}};function r(n,r,c,d,u,m,g,p,y,f,h){Pe(!0);let v="EPSG:3857",w=null,b=!0,x=15,k="ontouchstart"in window||navigator.msMaxTouchPoints;if(h){if(h.custombackgroundurl){let e=a.proj.transformExtent(h.bbox,"EPSG:4326",v);if(!h.geographic){let t=e[3]-e[1],a=(e[2]+e[0])/2,o=(e[3]+e[1])/2,s=Math.round(t/h.imgheight),l=Math.round(h.imgwidth*s),n=Math.round(h.imgheight*s);e=[a-l/2,o-n/2,a+l/2,o+n/2],x=5}w=new a.layer.Image({title:h.layername,name:h.layername,type:h.layertype,source:new a.source.ImageStatic({url:h.custombackgroundurl,imageExtent:e}),opacity:1})}else if(h.wmsurl){let e={source:new a.source.TileWMS({url:h.wmsurl,params:h.wmsparams}),type:h.layertype,title:h.layername,name:h.layername};if(h.bbox[0]&&h.bbox[1]&&h.bbox[2]&&h.bbox[3]){let t=a.proj.transformExtent(h.bbox,"EPSG:4326",v);e.extent=t}w=new a.layer.Tile(e)}b=h.geographic}!1===b&&(d=!0,e("#autolocate").hide());let P,S,E=t.imageUrl("success_mark","treasurehunt"),G=t.imageUrl("failure_mark","treasurehunt"),T=t.imageUrl("bootstrap/my_location_3","treasurehunt"),C={},_=[],I=[],q=!1,F=!1,j=!1,V=!1,z=!1,A=!0,M=!1,D=0,L=new a.style.Text({textAlign:"center",scale:1.3,fill:new a.style.Fill({color:"#ffffff"}),stroke:new a.style.Stroke({color:"#000000",width:3.5})}),R=new a.style.Text({textAlign:"center",scale:1.4,fill:new a.style.Fill({color:"#fff"}),stroke:new a.style.Stroke({color:"#0097a7",width:3.5})}),$=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:E}),text:L,zIndex:"Infinity"}),O=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:G}),text:L,zIndex:"Infinity"}),N=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:E}),text:R,zIndex:"Infinity"}),Q=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:G}),text:R,zIndex:"Infinity"}),W=new a.style.Style({image:new a.style.Circle({radius:6,fill:new a.style.Fill({color:[0,0,0,1]}),stroke:new a.style.Stroke({color:[255,255,255,1],width:2})})}),B=new a.style.Style({fill:new a.style.Fill({color:[255,255,255,.3]}),stroke:new a.style.Stroke({color:[0,0,0,.5],width:1}),zIndex:-1}),H=new a.style.Style({image:new a.style.Icon({anchor:[.5,.9],opacity:1,scale:1,src:T})}),U=[],Z=new a.format.GeoJSON,K=new a.source.Vector({projection:"EPSG:3857"}),X=new a.layer.Vector({source:K,style:function(e){let t=e.get("stageposition");if(0===t){let e=new a.style.Fill({color:"rgba(0,0,0,0.1)"}),t=new a.style.Stroke({color:"#0097a7",width:2});return[new a.style.Style({image:new a.style.Circle({fill:e,stroke:t,radius:5}),fill:e,stroke:t,text:new a.style.Text({text:n.startfromhere,textAlign:"center",fill:new a.style.Fill({color:"rgb(255,255,255)"}),stroke:new a.style.Stroke({color:"#0097a7",width:2}),overflow:!0,scale:2})})]}if(!e.get("geometrysolved"))return O.getText().setText(""+t),[O];return $.getText().setText(""+t),[$]}}),Y=new a.layer.Tile({visible:!1,source:new a.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})});Y.set("name",n.aerialview);let J=new a.layer.Tile({source:new a.source.OSM});J.set("name",n.roadview);let ee=[],te=[];h&&!1!==h.onlybase||(ee=[Y,J]),w&&("overlay"!=h.layertype?ee.push(w):te.push(w));let ae=new a.layer.Group({layers:ee});var oe=l.createCoordsOverlay("#mapplay","css/playerbootstrap/ol-popup.css",n.pegmanlabel);let se=null;ae.getLayers().forEach((e=>{e.setVisible(!1),se=e})),se.setVisible(!0);let le=new a.View({center:[0,0],zoom:2,minZoom:2}),ne=new a.interaction.Select({layers:[X],style:function(e){let t=e.get("stageposition");if(!e.get("geometrysolved"))return Q.getText().setText(""+t),[Q];return N.getText().setText(""+t),[N]},filter:e=>0!==e.get("stageposition")}),ie=new a.Feature;ie.setProperties({name:"user_accuracy"}),ie.setStyle(B);let re=new a.Feature;re.setProperties({name:"user_position"}),re.setStyle(W);let ce=new a.layer.Vector({source:new a.source.Vector({features:[ie,re]})}),de=new a.Feature;de.setGeometry(null),de.setStyle(H);let ue=new a.layer.Vector({source:new a.source.Vector({features:[de]})});U.push(ae),U=U.concat(te),U=U.concat([X,ce,ue]);let me=new a.control.Zoom({target:"navigation",className:"custom-zoom"}),ge=new a.Map({layers:U,overlays:[oe],controls:[me],target:"mapplay",view:le,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0});if(ge.addInteraction(ne),ye(!1,!0),P=setInterval((()=>{ye(!1,!1)}),p),function(t){t.getLayers().forEach((a=>{let o=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.getLayers().forEach((e=>{e===a?e.setVisible(!0):e.setVisible(!1)}))})),s=e("<div>",{text:a.get("name"),class:"layer-item "+(a.getVisible()?"":"unchecked")}).append(e("<i class='fa fa-check-circle'>"));o.append(s),a.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(o)}))}(ae),te.forEach((e=>{fe(e)})),y&&f){let e=l.addgpxlayer(ge,r,c,n,f,"trackgroup");e.set("name",e.get("title"));let t=e.getLayers().item(0),a=t.get("title");t.set("name",a),t.setVisible(!1),fe(t)}function pe(e,t,a){let o=e.getView();a?o.fit(a,{duration:700}):o.animate({zoom:x,center:t,duration:700})}function ye(t,s,l,i){let r,p,f,h;f=d?de.getGeometry():re.getGeometry(),f&&(p=Z.writeGeometryObject(f,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),l&&(Pe(!0),h=l),t&&(r=p,Pe(!0)),o.call([{methodname:"mod_treasurehunt_user_progress",args:{userprogress:{treasurehuntid:c,attempttimestamp:m,roadtimestamp:g,playwithoutmoving:d,groupmode:u,initialize:s,location:r,currentposition:y&&!d?p:void 0,selectedanswerid:h,qoaremoved:M,qrtext:i}}}])[0].done((o=>{if(M=o.qoaremoved,z=o.roadfinished,A=o.available,Pe(!1),(t||l)&&(null!==o.status&&A&&we(o.status.msg),de.setGeometry(null)),d!=o.playwithoutmoving&&((d=o.playwithoutmoving)||de.setGeometry(null)),u!=o.groupmode&&(u=o.groupmode),m===o.attempttimestamp&&g===o.roadtimestamp&&!s&&A||(m=o.attempttimestamp,g=o.roadtimestamp,o.attempthistory.length>0&&(I=o.attempthistory,q=!0),(o.attempts||o.firststagegeom)&&(K.clear(),o.firststagegeom&&K.addFeatures(Z.readFeatures(o.firststagegeom,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),o.attempts.features.length>0&&K.addFeatures(Z.readFeatures(o.attempts,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"}))),o.lastsuccessfulstage&&(C=o.lastsuccessfulstage,F=!0,be("#cluepage"),e("#validateqr").hide(),""!==C.question?(j=!0,e("#validatelocation").hide()):C.activitysolved?(e("#validatelocation").show(),o.qrexpected&&e("#validateqr").show()):e("#validatelocation").hide()),(o.firststagegeom||s)&&(V=!0),F&&(C.clue=C.clue.replace(/color/gm,"color-disabled"),e("#lastsuccessfulstageclue").html(C.clue),e("#lastsuccessfulstagename").text(C.name),e("#lastsuccesfulstagepos").text(C.position+" / "+C.totalnumber),""!==C.question?e("#questionbutton").show():e("#questionbutton").hide(),F=!1),function(){if(V){let e=K.getFeatures();1===e.length&&e[0].getGeometry()instanceof a.geom.Point?pe(ge,e[0].getGeometry().getCoordinates()):pe(ge,null,K.getExtent()),V=!1}}(),function(){if(j){C.question=C.question.replace(/color/gm,"color-disabled"),e("#questionform").html("<legend>"+C.question+"</legend>");let t=1;e.each(C.answers,((a,o)=>{let s="answer"+t;o.answertext=o.answertext.replace(/color/gm,"color-disabled"),e("#questionform").append(`<div class="form-check">\n                <input class="form-check-input" type="radio" name="answers" id="${s}" value="${o.id}">\n                <label class="form-check-label" for="${s}">\n                  ${o.answertext}\n                </label>\n            </div>`),t++})),j=!1}}(),function(){if(q){let t=e("#historylist");t.html(""),q=!1,0===I.length?e("<li>"+n.noattempts+"</li>").appendTo(t):I.forEach((a=>{e("<li><span class='ui-btn-icon-left "+(a.penalty?"ui-icon-delete failedattempt":"ui-icon-check successfulattempt")+"' style='position:relative'></span>"+a.string+"</li>").appendTo(t)}))}}()),o.infomsg.length>0){let t="";_.forEach((e=>{t+="<p>"+e+"</p>"})),o.infomsg.forEach((e=>{_.push(e),t+="<p>"+e+"</p>"})),e("#notificationsPopup .update-list").html(t),be("#notificationsPopup")}z||e("#roadended").hide(),!z&&A||(e("#validatelocation").hide(),e("#question_button").hide(),e("#roadended").show(),de.setGeometry(null),d=!1,clearInterval(P),e("#mapplay").css("opacity","0.8"))})).fail((t=>{e("#errorPopup .play-modal-content").text(t.message),be("#errorPopup"),clearInterval(P)}))}function fe(t){let a=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.setVisible(!t.getVisible())})),o=e.parseHTML(t.get("name")),s=e("<div>",{class:"layer-item "+(t.getVisible()?"":"unchecked")}).append(o,e("<i class='fa fa-check-circle'>"));a.append(s),t.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(a)}let he=new a.Geolocation({projection:le.getProjection(),trackingOptions:{enableHighAccuracy:!0,maximumAge:0,timeout:1e4}});he.on("change:position",(()=>{let e=he.getPosition();re.setGeometry(e?new a.geom.Point(e):null),he.get("center")&&(pe(ge,e),he.setProperties({center:!1})),he.get("validate_location")&&(ye(!0,!1),he.setProperties({validate_location:!1}))})),he.on("change:accuracyGeometry",(()=>{ie.setGeometry(he.getAccuracyGeometry())}));let ve=!1;function we(t){const a=e(`<div class='play-toast slide-in-bottom'>${t}</div>`);a.appendTo(e(".play-toast-container")),setTimeout((()=>a.addClass("slide-out-top")),3e3),setTimeout((()=>a.remove()),3500)}function be(t){xe();const a=e(t);a.trigger("modal:open"),a.addClass("active"),e(`${t} .modal-mask`).addClass("active dismissible")}function xe(){const t=e(".play-modal.active");t.trigger("modal:close"),t.removeClass("active"),e(".modal-mask").removeClass("active dismissible")}function ke(e,t){return`<div class="card">\n          <div class="card-body">\n            <h5 class="card-title">${e}</h5>\n            <h6 class="card-subtitle text-muted">${t}</h6>\n          </div>\n      </div>`}function Pe(t){t?e(".global-loader").addClass("active"):e(".global-loader").removeClass("active")}function Se(e){xe(),we("QR code readed: "+e),ye(!1,!1,null,e)}function Ee(t){"string"==typeof t?e("#errorQR").text(t):(null!==t.cameras[t.camera].name&&e("#errorQR").text(t.cameras[t.camera].name),t.cameras.length>1?e("#nextcamera").show():e("#nextcamera").hide())}he.on("error",(e=>{he.setProperties({user_denied:!0}),we(e.message),e.code==e.PERMISSION_DENIED&&y&&!d&&0==ve&&setTimeout((()=>{be("#geolocationPopup"),ve=!0}),500)})),he.setTracking(y),k||ge.on("pointermove",(e=>{if(e.dragging)return;const t=ge.getEventPixel(e.originalEvent);let o=!1;ge.forEachFeatureAtPixel(t,(e=>{e.getGeometry()instanceof a.geom.MultiPolygon||(o=!0)}),{layerFilter:e=>e===X}),ge.getTargetElement().style.cursor=o?"pointer":"crosshair"})),ne.on("select",(t=>{if(1===t.selected.length){let a=t.selected[0].get("name"),o=t.selected[0].get("clue"),s=t.selected[0].get("info"),l="",i="";s&&(l="<p>"+s+"</p>"),t.selected[0].get("geometrysolved")?a&&o?(i=n.stageovercome,l+=ke(n.stagename,a),l+=ke(n.stageclue,o)):i=n.discoveredlocation:i=n.failedlocation,e("#infoStagePopup .title").text(i),e("#infoStagePopup .play-modal-content").html(l),be("#infoStagePopup")}})),ge.on("click",(e=>{let t=!1;if(ge.forEachFeatureAtPixel(ge.getEventPixel(e.originalEvent),(e=>{if(0===e.get("stageposition")||"user_position"===e.get("name")||"user_accuracy"===e.get("name"))return!1;t=!0})),d&&!t){let t=ge.getEventCoordinate(e.originalEvent);de.setGeometry(t?new a.geom.Point(t):null),(null===h||h.geographic)&&oe.setPosition(e.coordinate)}})),e("#searchInput").on("input",(t=>{S&&S.abort(),D&&clearTimeout(D);const o=e("#searchsResults"),l=t.target.value;o.html(""),l&&l.length>2&&(e(".search-loading").addClass("active"),D=setTimeout((()=>{S=s.search(l).done((t=>{e(".search-loading").removeClass("active"),0===t.length?o.html("<li class='list-group-item'>"+n.noresults+"</li>"):e.each(t,((t,s)=>{let l=e("<button>",{type:"button",class:"list-group-item list-group-item-action"}).appendTo(o).click((()=>{let t=[];t[0]=parseFloat(s.boundingbox[2]),t[1]=parseFloat(s.boundingbox[0]),t[2]=parseFloat(s.boundingbox[3]),t[3]=parseFloat(s.boundingbox[1]),t=a.proj.transformExtent(t,"EPSG:4326","EPSG:3857"),pe(ge,null,t),e("#searchpanel").removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),n=e("<div>",{text:s.display_name,class:"search-option"}).append(e("<i class='fa fa-chevron-circle-right'>"));l.append(n)}))})).fail((()=>{})).always((()=>{S=null}))}),400))})),e("#infoStagePopup").on("modal:close",(()=>{ne.getFeatures().clear()})),e("#acceptupdates").on("click",(()=>{_=[]})),e("#qrpage").on("modal:open",(()=>{i.loadQR(Se,Ee)})),e("#qrpage").on("modal:close",(()=>{i.unloadQR(Ee)})),e("#nextcamera").on("click",(()=>{let e=i.getDetectedCameras();if(null!==e){we("Give access to:"+e[i.getnextwebCam()].name)}i.setnextwebcam(Ee)})),e(window).on("resize",(()=>{ge.updateSize()})),b&&e("#autolocate").on("click",(()=>{he.get("user_denied")?be("#geolocationPopup"):function(){const e=he.getPosition();pe(ge,e)}()})),e("#infopanel").on("sidebar:close",(()=>{ne.getFeatures().clear()})),e("#sendLocation").on("click",(()=>{d&&!de.getGeometry()?we(n.nomarks):ye(!0,!1)})),e("#sendAnswer").on("click",(t=>{let a=e("#questionform input[type='radio']:checked");A?0===a.length?(t.preventDefault(),we(n.noanswerselected)):ye(!1,!1,a.val()):(t.preventDefault(),we(n.timeexceeded))})),e("#validatelocation").on("click",(e=>z?(e.preventDefault(),void we(n.huntcompleted)):A?""!==C.question?(e.preventDefault(),we(n.answerwarning),void be("#cluepage")):C.activitysolved?void 0:(e.preventDefault(),we(n.activitytoendwarning),void be("#cluepage")):(e.preventDefault(),void we(n.timeexceeded)))),e(document).on("click",'*[data-rel="sidebar"]',(t=>{const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("sidebar:open"),o.addClass("active"),null!==a.dataset.dismissible&&e(".sidebar-mask").addClass("active dismissible")})),e(document).on("click",".close-sidebar, .sidebar-mask",(()=>{const t=e(".sidebar.active");t.trigger("sidebar:close"),t.removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),e(document).on("click",'*[data-rel="modal"]',(t=>{xe();const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("modal:open"),o.addClass("active"),e(a.dataset.ref+" .modal-mask").addClass("active"),null!==a.dataset.dismissible&&e(a.dataset.ref+" .modal-mask").addClass("dismissible")})),e(document).on("click",".close-modal, .modal-mask.dismissible",(()=>{xe()}))}}));