/**
 * @module    mod_treasurehunt/play
 * @package   mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>, Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(["jquery","core/url","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/viewgpx","mod_treasurehunt/webqr","mod_treasurehunt/jquery.truncate","mod_treasurehunt/jquery.mobile-config","mod_treasurehunt/jquerymobile"],(function(e,t,o,n,i,a,s){return console.log("loading play.js with jquery "+e().jquery),{playtreasurehunt:function(e,t,o,n,i,a,s,r,c,u){console.log("loading i18n strings");["stageovercome","failedlocation","stage","stagename","stageclue","question","noanswerselected","timeexceeded","searching","continue","noattempts","aerialview","roadview","noresults","startfromhere","nomarks","updates","activitytoendwarning","huntcompleted","discoveredlocation","answerwarning","error","pegmanlabel"].map((function(e){return{key:e,component:"treasurehunt"}}));if(i18n=i18nplay,null!=u&&null!==u.custombackgroundurl){console.log("Detecting custom background image dimensions.");var d=new Image;d.addEventListener("load",(function(){u.imgwidth=this.naturalWidth,u.imgheight=this.naturalHeight,console.log("image is "+this.naturalWidth+"x"+this.naturalHeight+"pixels"),l(i18n,e,t,o,n,i,a,s,r,c,u)})),d.src=u.custombackgroundurl}else l(i18n,e,t,o,n,i,a,s,r,c,u)}};function l(l,r,c,u,d,p,g,m,h,f,y){console.log("init player Openlayers"),e.mobile.loading("show");var w="EPSG:3857",v=null,b=!0,x=15;if(null!=y){if(null!=y.custombackgroundurl){console.log("config custom background image");var k=o.proj.transformExtent(y.bbox,"EPSG:4326",w);if(!y.geographic){k[2],k[0];var T=k[3]-k[1],S=(k[2]+k[0])/2,P=(k[3]+k[1])/2,q=Math.round(T/y.imgheight),E=Math.round(y.imgwidth*q),G=Math.round(y.imgheight*q);k=[S-E/2,P-G/2,S+E/2,P+G/2],x=5}v=new o.layer.Image({title:y.layername,name:y.layername,type:y.layertype,source:new o.source.ImageStatic({url:y.custombackgroundurl,imageExtent:k}),opacity:1})}else if(null!==y.wmsurl){console.log("config custom wms server: "+y.wmsurl);var I={source:new o.source.TileWMS({url:y.wmsurl,params:y.wmsparams}),type:y.layertype,title:y.layername,name:y.layername};if(null!==y.bbox[0]&&null!==y.bbox[1]&&null!==y.bbox[2]&&null!==y.bbox[3]){var C=o.proj.transformExtent(y.bbox,"EPSG:4326",w);I.extent=C}v=new o.layer.Tile(I)}b=y.geographic}!1===b&&(console.log("geographic tools disabled"),u=!0,e("#autolocate").hide());var _,j=t.imageUrl("success_mark","treasurehunt"),F=t.imageUrl("failure_mark","treasurehunt"),A=t.imageUrl("my_location","treasurehunt"),V={},z=0,D=0,R=[],L=[],M=!1,Q=!1,O=!1,W=!1,H=!1,N=!0,B=!1;let U,Z=0;var K=new o.style.Text({textAlign:"center",scale:1.3,fill:new o.style.Fill({color:"#fff"}),stroke:new o.style.Stroke({color:"#000",width:3.5})}),X=new o.style.Text({textAlign:"center",scale:1.4,fill:new o.style.Fill({color:"#fff"}),stroke:new o.style.Stroke({color:"#3399CC",width:3.5})}),Y=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:j}),text:K,zIndex:"Infinity"}),J=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:F}),text:K,zIndex:"Infinity"}),$=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:j}),text:X,zIndex:"Infinity"}),ee=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:F}),text:X,zIndex:"Infinity"}),te=new o.style.Style({image:new o.style.Circle({radius:6,fill:new o.style.Fill({color:[0,0,0,1]}),stroke:new o.style.Stroke({color:[255,255,255,1],width:2})})}),oe=new o.style.Style({fill:new o.style.Fill({color:[255,255,255,.3]}),stroke:new o.style.Stroke({color:[0,0,0,.5],width:1}),zIndex:-1}),ne=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.35,src:A})}),ie=[],ae=new o.format.GeoJSON,se=new o.source.Vector({projection:"EPSG:3857"}),le=new o.layer.Vector({source:se,style:function(e,t){var n=e.get("stageposition");if(0===n){var i=new o.style.Fill({color:"rgba(255,255,255,0.4)"}),a=new o.style.Stroke({color:"#3399CC",width:1.25});return[new o.style.Style({image:new o.style.Circle({fill:i,stroke:a,radius:5}),fill:i,stroke:a,text:new o.style.Text({text:l.startfromhere,textAlign:"center",fill:new o.style.Fill({color:"rgb(255,255,255)"}),stroke:new o.style.Stroke({color:"#3399CC",width:2}),overflow:!0,scale:2})})]}if(!e.get("geometrysolved"))return J.getText().setText(""+n),[J];return Y.getText().setText(""+n),[Y]}}),re=new o.layer.Tile({visible:!1,source:new o.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})});re.set("name",l.aerialview);var ce=new o.layer.Tile({source:new o.source.OSM});ce.set("name",l.roadview);var ue=[],de=[];null!==y&&!1!==y.onlybase||(ue=[re,ce]),null!==v&&("overlay"!=y.layertype?ue.push(v):de.push(v));var pe=new o.layer.Group({layers:ue}),ge=a.createCoordsOverlay("#mapplay","css/playerfancy/ol-popup.css",l.pegmanlabel),me=null;pe.getLayers().forEach((function(e){e.setVisible(!1),me=e})),me.setVisible(!0);var he=new o.View({center:[0,0],zoom:2,minZoom:2}),fe=new o.interaction.Select({layers:[le],style:function(e,t){var o=e.get("stageposition");if(!e.get("geometrysolved"))return ee.getText().setText(""+o),[ee];return $.getText().setText(""+o),[$]},filter:function(e,t){return 0!==e.get("stageposition")}}),ye=new o.Feature;ye.setProperties({name:"user_accuracy"}),ye.setStyle(oe);var we=new o.Feature;we.setProperties({name:"user_position"}),we.setStyle(te);var ve=new o.layer.Vector({source:new o.source.Vector({features:[ye,we]})}),be=new o.Feature;be.setGeometry(null),be.setStyle(ne);var xe=new o.layer.Vector({source:new o.source.Vector({features:[be]})});ie.push(pe),ie=(ie=ie.concat(de)).concat([le,ve,xe]);var ke=new o.control.Zoom({target:"navigation",className:"custom-zoom"}),Te=new o.control.Attribution({collapsible:!1}),Se=new o.Map({layers:ie,overlays:[ge],controls:[ke,Te],target:"mapplay",view:he,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0});if(Se.addInteraction(fe),Ie(!1,!0),_=setInterval((function(){Ie(!1,!1)}),m),function(t){t.getLayers().forEach((function(o){var n=e("<li>",{"data-icon":"check",class:o.getVisible()?"checked":"unchecked"}).append(e("<a />",{text:o.get("name"),href:"#mappage"}).click((function(){t.getLayers().forEach((function(e){e===o?e.setVisible(!0):e.setVisible(!1)}))})));o.on("change:visible",(function(){e(n).toggleClass("checked unchecked")})),n.insertAfter("#baseLayer")}))}(pe),de.forEach((function(e){Fe(e)})),h&&f){var Pe=a.addgpxlayer(Se,r,c,l,f,"trackgroup");Pe.set("name",Pe.get("title"));var qe=Pe.getLayers().item(0),Ee=qe.get("title");qe.set("name",Ee),qe.setVisible(!1),Fe(qe)}function Ge(e,t,o){var n=e.getView();o?n.fit(o,{duration:700}):n.animate({zoom:x,center:t,duration:700})}function Ie(t,o,i,a){var s,r,m,f;(m=u?be.getGeometry():we.getGeometry())&&(r=ae.writeGeometryObject(m,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),i&&(e.mobile.loading("show"),f=i),t&&(s=r,e.mobile.loading("show")),n.call([{methodname:"mod_treasurehunt_user_progress",args:{userprogress:{treasurehuntid:c,attempttimestamp:p,roadtimestamp:g,playwithoutmoving:u,groupmode:d,initialize:o,location:s,currentposition:h&&!u?r:void 0,selectedanswerid:f,qoaremoved:B,qrtext:a}}}])[0].done((function(n){var a="";if(B=n.qoaremoved,H=n.roadfinished,N=n.available,e.mobile.loading("hide"),(t||i)&&null!==n.status&&N&&console.log(n.status.msg),u!=n.playwithoutmoving&&((u=n.playwithoutmoving)||be.setGeometry(null)),d!=n.groupmode&&(d=n.groupmode),p!==n.attempttimestamp||g!==n.roadtimestamp||o||!N){p=n.attempttimestamp,g=n.roadtimestamp,n.attempthistory.length>0&&(L=n.attempthistory,M=!0),(n.attempts||n.firststagegeom)&&(se.clear(),n.firststagegeom&&se.addFeatures(ae.readFeatures(n.firststagegeom,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),n.attempts.features.length>0&&se.addFeatures(ae.readFeatures(n.attempts,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"}))),n.lastsuccessfulstage&&(V=n.lastsuccessfulstage,Q=!0,e("#validateqr").hide(),""!==V.question?(O=!0,e("#validatelocation").show().addClass("ui-state-disabled"),We("question")):V.activitysolved?(e("#validatelocation").show().removeClass("ui-state-disabled"),We("clue"),n.qrexpected&&e("#validateqr").show()):(e("#validatelocation").show().addClass("ui-state-disabled"),We("question"))),(n.firststagegeom||o)&&(W=!0);var s=e.mobile.pageContainer.pagecontainer("getActivePage").prop("id");"mappage"===s||("historypage"===s?je():"questionpage"===s&&(""===V.question?e.mobile.pageContainer.pagecontainer("change","#mappage"):e.mobile.resetActivePageHeight())),function(){if(Q){e("#lastsuccessfulstagename").text(l.stage+":"+V.name),e("#lastsuccesfulstagepos").text(V.position+" / "+V.totalnumber);var t,o=100;V.clue=V.clue.replace(/color/gm,"color-disabled"),e("#lastsuccessfulstageclue").html(V.clue),V.clue.replace(/<(?:.|\n)*?>/gm,"").length>2*o?(e("#lastsuccessfulstageclue").truncate(2*o),t=' <a href="#historypage" data-transition="none" class="ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-icon-bullets ui-btn-icon-notext"></a> ',e("#lastsuccessfulstageclue").append(t)):t=V.clue,e("[id=lastsuccessfulstagename2]").text(V.name),e("[id=lastsuccesfulstagepos2").text(V.position+" / "+V.totalnumber),e("[id=lastsuccessfulstageclue2]").html(V.clue),""!==V.question?(e("#lastsuccessfulstageclue").append("<a href='#questionpage' data-transition='none' class='ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-mini ui-icon-comment'>"+l.question+"</a>"),e("[id=lastsuccessfulstageclue2]").append("<a href='#questionpage' data-transition='none' class='ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-mini ui-icon-comment'>"+l.question+"</a>"),e("#sendAnswer").show()):(e("#questionform").html(""),e("#sendAnswer").hide()),Q=!1}}(),Ce(),_e()}n.infomsg.length>0&&(R.forEach((function(e){a+="<p>"+e+"</p>"})),n.infomsg.forEach((function(e){R.push(e),a+="<p>"+e+"</p>"})),Me("displayupdates",l.updates,a)),H||e("#roadended").hide(),!H&&N||(e("#validatelocation").show().addClass("ui-state-disabled"),e("#question_button").hide(),e("#roadended").show(),be.setGeometry(null),u=!1,clearInterval(_),e("#mapplay").css("opacity","0.8"))})).fail((function(e){console.log(e),Me("displayerror",l.error,e.message),clearInterval(_)}))}function Ce(){if(W){var e=se.getFeatures();1===e.length&&e[0].getGeometry()instanceof o.geom.Point?Ge(Se,e[0].getGeometry().getCoordinates()):Ge(Se,null,se.getExtent()),W=!1}}function _e(){if(O){V.question=V.question.replace(/color/gm,"color-disabled");var t="<legend>"+V.question+"</legend>",o=1;e.each(V.answers,(function(e,n){var i="answer"+o;n.answertext=n.answertext.replace(/color/gm,"color-disabled"),t+='<div class="answer"><input type="radio" name="answers" id="'+i+'"value="'+n.id+'"><label style="color:white" for="'+i+'">'+n.answertext+"</label></div>",o++})),e("#questionform").html(t).scrollTop(),e("#questionform").enhanceWithin(),setTimeout((()=>e("#questionform input").removeClass("ui-helper-hidden-accessible")),1),O=!1}}function je(){if(M){var t=e("#historylist");t.html(""),M=!1,0===L.length?e("<li>"+l.noattempts+"</li>").appendTo(t):L.forEach((function(o){e("<li><span class='ui-btn-icon-left "+(o.penalty?"ui-icon-delete failedattempt":"ui-icon-check successfulattempt")+"' style='position:relative'></span>"+o.string+"</li>").appendTo(t)})),t.listview("refresh"),t.trigger("updatelayout")}}function Fe(t){var o=e.parseHTML(t.get("name")),n=e("<li>",{"data-icon":"check",class:t.getVisible()?"checked":"unchecked"}).append(e("<a />",{href:"#mappage"}).click((function(){t.setVisible(!t.getVisible())})).append(o));t.on("change:visible",(function(){e(n).toggleClass("checked unchecked")})),n.insertAfter("#baseLayer")}var Ae=new o.Geolocation({projection:he.getProjection(),trackingOptions:{enableHighAccuracy:!0,maximumAge:0,timeout:1e4}});Ae.on("change:position",(function(){var t=this.getPosition();we.setGeometry(t?new o.geom.Point(t):null),this.get("center")&&(Ge(Se,t),this.setProperties({center:!1})),this.get("validate_location")&&(Ie(!0,!1),this.setProperties({validate_location:!1})),e.mobile.loading("hide")})),Ae.on("change:accuracyGeometry",(function(){ye.setGeometry(this.getAccuracyGeometry()),e.mobile.loading("hide")}));var Ve=!1;(Ae.on("error",(function(t){e.mobile.loading("hide"),Ae.setProperties({user_denied:!0}),Re(t.message),t.code==t.PERMISSION_DENIED&&h&&!u&&0==Ve&&setTimeout((function(){e("#popupgeoloc").popup("open",{positionTo:"window"}),Ve=!0}),500)})),Ae.setTracking(h),fe.on("select",(function(t){if(1===t.selected.length)if(V.position===t.selected[0].get("stageposition")&&t.selected[0].get("geometrysolved")&&!H&&N)Le(),e("#lastsuccessfulstage").collapsible("expand");else{var o,n=t.selected[0].get("name"),i=t.selected[0].get("clue"),a=t.selected[0].get("info"),s="";t.selected[0].get("geometrysolved")?n&&i?(o=l.stageovercome,s=Oe(l.stagename,n),s+=Oe(l.stageclue,i)):o=l.discoveredlocation:o=l.failedlocation,a&&(s+="<p>"+a+"</p>"),Me("infostage",o,s)}})),Se.on("click",(function(e){var t=!1;if(Se.forEachFeatureAtPixel(Se.getEventPixel(e.originalEvent),(function(e,o){if(0===e.get("stageposition")||"user_position"===e.get("name")||"user_accuracy"===e.get("name"))return!1;t=!0})),u&&!t){var n=Se.getEventCoordinate(e.originalEvent);be.setGeometry(n?new o.geom.Point(n):null),(null===y||y.geographic)&&ge.setPosition(e.coordinate)}})),e("#autocomplete").on("filterablebeforefilter",(function(t,n){if(!b)return;U&&U.abort(),Z&&clearTimeout(Z);let a=e(this),s=e(n.input).val();a.html(""),s&&s.length>2&&(e.mobile.loading("show",{text:l.searching,textVisible:!0,theme:"b"}),Z=setTimeout((()=>{U=i.search(s).done((t=>{0===t.length?a.html("<li data-filtertext='"+s+"'>"+l.noresults+"</li>"):e.each(t,((t,n)=>{e("<li data-filtertext='"+s+"'>").hide().append(e("<a href='#'>").text(n.display_name)).appendTo(a).click((function(){var t=[];t[0]=parseFloat(n.boundingbox[2]),t[1]=parseFloat(n.boundingbox[0]),t[2]=parseFloat(n.boundingbox[3]),t[3]=parseFloat(n.boundingbox[1]),t=o.proj.transformExtent(t,"EPSG:4326","EPSG:3857"),Ge(Se,null,t),e("#searchpanel").panel("close")})).show()})),a.listview("refresh"),a.trigger("updatelayout")})).fail((()=>{})).always((()=>{U=null,e.mobile.loading("hide")}))}),400))})),e("#infopanel").on("collapsibleexpand","[data-role='collapsible']",(function(t,o){var n=e("#infopanel .ui-panel-inner");n.animate({scrollTop:parseInt(e(this).offset().top-n.offset().top+n.scrollTop())},500)})),e(document).on("popupbeforeposition",(function(){var t=e(window).height()-200+"px";e('.ui-popup [data-role="content"]').css("max-height",t)})),e(document).on("popupafterclose",".ui-popup:not(#QRdialog):not(#popupdialog):not(#popupgeoloc)",(function(){e(this).remove(),fe.getFeatures().clear()})),e(document).on("click","#acceptupdates",(function(){R=[]})),e(window).on("pagecontainershow resize",(function(t,o){e.mobile.resetActivePageHeight();var n=e.mobile.pageContainer.pagecontainer("getActivePage").prop("id");"mappage"===n?"resize"===t.type?setTimeout((function(){Se.updateSize()}),200):(Se.updateSize(),Ce()):"historypage"===n?"pagecontainershow"===t.type&&je():"questionpage"===n&&"pagecontainershow"===t.type&&(null!=V.question&&""!==V.question||!1===V.activitysolved?_e():e.mobile.pageContainer.pagecontainer("change","#mappage")),setTimeout((()=>{var e=document.querySelector("#questionpage").style;e.setProperty("padding-top",e.paddingTop,"important")}),200)})),b&&e("#autolocate").on("click",(function(){Ae.get("user_denied")?e("#popupgeoloc").popup("open",{positionTo:"window"}):(position=Ae.getPosition(),Ge(Se,position))})),e("#infopanel").panel({beforeclose:function(){fe.getFeatures().clear()}}),e("#sendLocation").on("click",(function(){u&&null===be.getGeometry()?Re(l.nomarks):Ie(!0,!1)})),e("#sendAnswer").on("click",(function(t){var o=e("#questionform input[type='radio']:checked");N?0===o.length?(t.preventDefault(),Re(l.noanswerselected)):Ie(!1,!1,o.val()):(t.preventDefault(),Re(l.timeexceeded))})),e("#validatelocation").on("click",(function(e){return H?(e.preventDefault(),void Re(l.huntcompleted)):N?""!==V.question?(e.preventDefault(),Re(l.answerwarning),void Le()):V.activitysolved?void 0:(e.preventDefault(),Re(l.activitytoendwarning),void Le()):(e.preventDefault(),void Re(l.timeexceeded))})),!1===e.mobile.autoInitializePage)&&(e("#container").show(),e("#loader").remove(),e.mobile.initializePage(),document.querySelector("meta[name=viewport]").setAttribute("content","width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"),e("#QRdialog").popup({beforeposition:function(t,o){e(this).width(.9*window.innerWidth),e(this).height(.9*window.innerHeight)},afteropen:function(t,o){var n=e(this).find("div[data-role='content']").first(),i=e(this).find("div[data-role='header']").first(),a=parseInt(n.css("padding-top"))+parseInt(n.css("padding-bottom"));n.css("max-height","1000px"),e("#previewVideoDiv").width(e(this).width()-a).height(e(this).height()-e("#previewQRbuttons").height()-i.height()-2*a),e("#previewQRvideo").show(),s.loadQR(ze,De)},afterclose:function(e,t){s.unloadQR(De)}.bind(this)}));function ze(t){e("#QRdialog").popup("close"),console.log(t),Re("QR code readed: "+t),Ie(!1,!1,null,t)}function De(t){"string"==typeof t?e("#errorQR").text(t):(null!==t.cameras[t.camera].name&&e("#errorQR").text(t.cameras[t.camera].name),t.cameras.length>1?e("#nextcamera").show():e("#nextcamera").hide())}function Re(t){e(".toast").length>0?setTimeout((function(){Re(t)}),2500):e("<div class='ui-loader ui-overlay-shadow  ui-corner-all toast'><p>"+t+"</p></div>").css({left:(e(window).width()-284)/2,top:e(window).height()/2}).appendTo(e.mobile.pageContainer).delay(2e3).fadeOut(400,(function(){e(this).remove()}))}function Le(){e("#bigbtn").click()}function Me(t,o,n){var i=e('<div data-role="header"><h2>'+o+"</h2></div>"),a=e('<div data-role="content" class="ui-content ui-overlay-b">'+n+"</div>"),s=e('<div data-role="popup" id="'+t+'"data-theme="b" data-transition="slidedown"></div>');if("infostage"===t&&e('<a href="#" data-rel="back" class="ui-btn ui-corner-allui-btn-b ui-icon-delete ui-btn-icon-notext ui-btn-right"></a>').appendTo(i),"displayupdates"===t){e('<p class="center-wrapper"><a id="acceptupdates" href="#" data-rel="back"class="ui-btn center-button ui-mini ui-btn-inline">'+l.continue+"</a></p>").appendTo(a);var c={"data-dismissible":!1,"data-overlay-theme":"b"};e(s).attr(c)}if("displayerror"===t){e('<p class="center-wrapper"><a href="view.php?id='+r+'" class="ui-btn  center-button ui-mini ui-icon-forward ui-btn-inline ui-btn-icon-left"data-ajax="false">'+l.continue+"</a></p>").appendTo(a);c={"data-dismissible":!1,"data-overlay-theme":"b"};e(s).attr(c)}if(e(i).appendTo(e(s).appendTo(e.mobile.activePage).popup()).toolbar().after(a),(D=e(a).find("img")).length>0){e.mobile.loading("show"),D.one("load",(function(){z++,D.length===z&&(Qe(s),z=0,clearTimeout(u),e.mobile.loading("hide"))}));var u=setTimeout((function(){Qe(s),e.mobile.loading("hide")}),2e3)}else Qe(s)}function Qe(t){e(".ui-popup-active").length>0?(e(".ui-popup").popup("close"),setTimeout((function(){e(t).popup("open",{positionTo:"window"})}),1e3)):e(t).popup("open",{positionTo:"window"})}function Oe(e,t){return'<div class="ui-bar ui-bar-a">'+e+'</div><div class="ui-body ui-body-a">'+t+"</div>"}function We(t){var o=e("#bigbtn")[0];o.href="#"+t+"page",btnImg=e("img",o)[0];var n=btnImg.src.replace(/btn_(\w+)$/,"btn_"+t);btnImg.src=n}e("#nextcamera").on("click",(function(){var e=s.getDetectedCameras();null!==e&&Re("Give access to:"+e[s.getnextwebCam()].name);s.setnextwebcam(De)}))}}));